<template>
  <div class="container mt-3 mt-sm-5">
    <div>
      Filter
      <ul class="list-unstyled">
        <li v-for="filterText in filters" :key="filterText" :data-testid="`filter-${filterText}`">
          <input type="radio" name="filter" v-model="filter" :value="filterText">
          {{filterText}}
        </li>
      </ul>
    </div>
    <input data-testid="todo-input" class="form-control" placeholder="New item" v-model="newTodo" @keydown.enter="addTodo">
    <ul class="list-unstyled" data-testid="todo-container">
      <li v-for="todo in filteredTodos" :key="todo.id" :class="{ completed: todo.completed }">
        <input type="checkbox" v-model="todo.completed">
        {{ todo.text }}
      </li>
    </ul>
    <button type="button" @click="clearCompletedTodo">Clear completed todo</button>
  </div>
</template>

<script>
export default {
  name: 'TodoApp',
  data() {
    return {
      newTodo: '',
      todos: [],
      filter: 'all',
      filters: ['all', 'completed', 'incompleted']
    };
  },
  methods: {
    addTodo() {
      this.todos.push({ text: this.newTodo, completed: false, id: Date.now() });
      this.newTodo = '';
    },
    clearCompletedTodo() {
      this.todos = this.todos.filter(f => !f.completed)
    }
  },
  mounted() {
    if (localStorage.getItem('todos')) this.todos = JSON.parse(localStorage.getItem('todos'));
  },
  watch: {
    todos: {
      handler() {
        localStorage.setItem('todos', JSON.stringify(this.todos));
      },
      deep: true,
    },
  },
  computed: {
    filteredTodos() {
      const array = this.todos || [];
      switch(this.filter) {
        case 'completed':
          return array.filter(f => f.completed)
        case 'incompleted':
          return array.filter(f => !f.completed)
        default:
          return array
      }
    }
  }
};
</script>

<style scoped>
.completed { text-decoration: line-through; }
</style>
